/*!
 * @file script_method.h
 * @brief Definition of ...
*/

#ifndef _SCRIPT_METHOD_H
#define _SCRIPT_METHOD_H

#include <vector>

#include "executor/executor_lua_state.h"
#include "executor/executor_member.h"

class ScriptMethod
{
public:
  ScriptMethod();
  ~ScriptMethod();

  ScriptMethod* addMethod(const std::string& methodName, const Executor<lua_State*>& executor);

  unsigned int size() const { return methods.size(); };

  const std::string& name(unsigned int methodNumber) const { return methods[methodNumber].name; };
  const Executor<lua_State*>* executor(unsigned int methodNumber) const { return methods[methodNumber].executor; };


private:
  struct Method
  {
    Method(const std::string& name, const Executor<lua_State*>& executor);
    std::string             name;
    Executor<lua_State*>*   executor;
  };

  std::vector<Method> methods;
};

#endif /* _SCRIPT_METHOD_H */
